#
#
#    datasource.py
#
#    Meter data source.
#
#    Copyright (C) 2023 by Matt Roberts.
#    License: GNU GPL3 (www.gnu.org)
#
#

import sys
import os
import os.path
import subprocess
import time

process = None

#
#  watchstate(args, callback)
#
def watchstate(args, callback):
	global process
	process = subprocess.Popen(args, stdout=subprocess.PIPE)
	try:
		while process:
			l = process.stdout.readline()
			if not l: return
			l = l.strip()
			if not l: continue
			l = l.decode("utf-8") 
			if callback:
				try:
					callback(l)
				except:
					pass
	except:
		pass
	finally:
		try:
			process.stdout.close()
		except:
			pass

#
#  stop()
#
def stop():
	global process
	if process:
		process.terminate()

#
#  unit tests
#
if __name__ == '__main__':
	# the callback
	def callback(line):
		sys.stdout.write('Line: "%s"\n' % line)

	# the test
	watchstate(sys.argv[1:], callback)

# EOF
